﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace UHFReaderWinCE
{
    public partial class Condition : Form
    {
        public Condition()
        {
            InitializeComponent();
        }

      
        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }

      
        private void Condition_Load(object sender, EventArgs e)
        {
            int i = 0;
            for (i=0;i<16;i++)
            {
                com_Q.Items.Add(i.ToString());
            }
            com_Q.SelectedIndex = MaskInfo.QValue;

            for (i = 0; i < 4; i++)
            {
                com_S.Items.Add(i.ToString());
            }
            com_S.SelectedIndex = MaskInfo.Session;
            if(MaskInfo.TIDFlag==0)
            {
                CheckBox_TID.Checked = false;
            }
            else
            {
                CheckBox_TID.Checked = true;
            }
            textBox12.Text = Convert.ToString(MaskInfo.AdrTID, 16).PadLeft(2, '0');
            textBox13.Text = Convert.ToString(MaskInfo.LenTID, 16).PadLeft(2, '0');

            if (MaskInfo.MaskFlag == 0)
            {
                CheckBox_Mask.Checked = false;
            }
            else
            {
                CheckBox_Mask.Checked = true;
            }
            switch (MaskInfo.MaskMem)
            {
            case 1:
                R_EPC.Checked = true;
            	break;
            case 2:
                R_TID.Checked = true;
                break;
            case 3:
                R_User.Checked = true;
                break;
            }
            maskadr_textbox.Text = ByteArrayToHexString(MaskInfo.MaskAdr);
            maskData_textBox.Text = ByteArrayToHexString(MaskInfo.MaskData);
            maskLen_textBox.Text = Convert.ToString(MaskInfo.MaskLen, 16).PadLeft(2, '0');

            i = 3;
            while (i <= 256)
            {
                comboBox5.Items.Add(Convert.ToString(i) + "*10ms");
                i = i + 1;
            }
            comboBox5.SelectedIndex = MaskInfo.scantime;
        }
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
            return sb.ToString().ToUpper();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (CheckBox_TID.Checked)
            {
                if ((textBox12.Text.Length) != 2 || ((textBox13.Text.Length) != 2))
                {
                    MessageBox.Show("TID Parameter Error！");
                    return;
                }
            }
            if (CheckBox_Mask.Checked)
            {
                if ((maskadr_textbox.Text.Length != 4) || (maskLen_textBox.Text.Length != 2) || (maskData_textBox.Text.Length % 2 != 0) || (maskData_textBox.Text.Length == 0))
                {
                    MessageBox.Show("Mask data error!", "Error information");
                    return;
                }
            }
            if (CheckBox_TID.Checked)
            {
                MaskInfo.AdrTID = Convert.ToByte(textBox12.Text, 16);
                MaskInfo.LenTID = Convert.ToByte(textBox13.Text, 16);
                MaskInfo.TIDFlag = 1;
            }
            else
            {
                MaskInfo.AdrTID = 0;
                MaskInfo.LenTID = 0;
                MaskInfo.TIDFlag = 0;
            }
            if (CheckBox_Mask.Checked)
            {
                if (R_EPC.Checked) MaskInfo.MaskMem = 1;
                if (R_TID.Checked) MaskInfo.MaskMem = 2;
                if (R_User.Checked) MaskInfo.MaskMem = 3;
                MaskInfo.MaskAdr = HexStringToByteArray(maskadr_textbox.Text);
                MaskInfo.MaskLen = Convert.ToByte(maskLen_textBox.Text, 16);
                MaskInfo.MaskData = HexStringToByteArray(maskData_textBox.Text);
                MaskInfo.MaskFlag = 1;
            }
            else
                MaskInfo.MaskFlag = 0;
            MaskInfo.QValue = Convert.ToByte(com_Q.SelectedIndex);
            MaskInfo.Session = Convert.ToByte(com_S.SelectedIndex);
            MaskInfo.scantime = Convert.ToByte(comboBox5.SelectedIndex);
            Close();
        }

        private void CheckBox_Mask_CheckStateChanged(object sender, EventArgs e)
        {
            
        }

        private void com_S_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}