﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using UHFReaderWinCE;
using System.Collections;
using System.Resources;
using System.Reflection;
using System.IO.Ports;
using System.IO;
using System.Runtime.InteropServices;
using System.Threading;


namespace UHFReaderWinCE
{
    public partial class Form1 : Form
    {
        public const int MB_ICONEXCLAMATION = 48;

        [DllImport("coredll.dll")]
        public static extern bool MessageBeep(int uType);

        private byte readerAddr = 0xff;
        private bool fAppClose = false;
        private bool fComopen = false;
        private int fCmdRet = 0x30;
        private int m_band = 0;
        private const byte OK = 0x00;
        private const byte lengthError = 0x01;
        private const byte operationNotSupport = 0x0b;
        private const byte dataRangError = 0x03;
        private const byte cmdNotOperation = 0x04;
        private const byte EEPROM = 0x06;
        private const byte timeOut = 0x02;
        private const byte unknownError = 0x0f;
        private const byte communicationErr = 0x30;
        private const byte retCRCErr = 0x31;
        private const byte comPortOpened = 0x35;
        private const byte comPortClose = 0x36;
        private bool isStopInventory = false;
        private int CardNum1 = 0;
        ArrayList list = new ArrayList();
        private string fInventory_EPC_List; //存贮询查列表（如果读取的数据没有变化，则不进行刷新）
        private byte[] EPCAndID = new byte[5000];
        private byte Target=0;
        private byte InAnt=0;
        private byte Scantime=0;
        private byte FastFlag = 0;
        private int AA_times = 0;
        /// <summary>
        /// /////////以下公用字段用于询查设置参数

      
        /// </summary>
        public Form1()
        {
            InitializeComponent();
            btnConnect.Enabled = true;
            btnDisconnect.Enabled = false;
            radioButton4.Checked = true;
        }
        private string GetErrorCodeDesc(byte errorCode)
        {
            switch (errorCode)
            {
                case unknownError:
                    return "Unknown error";
                case cmdNotOperation:
                    return "CMD can't execute at current";
                case 0x33:
                    return "Utralight tag anticollision failed";
                case 0x32:
                    return "MF1 and Utralight tag collision";
                case 0x31:
                    return "Unallow more than one tag in RF field";
                case 0x30:
                    return "Anticollision failed";
                default:
                    return "";
            }
        }

        private string GetReturnCodeDesc(int retCode)
        {
            switch (retCode)
            {
                case OK: return "success";
                case lengthError: return "Command operand length error";
                case operationNotSupport: return "Command not supported";
                case EEPROM: return "E2PROM operation error";
                case timeOut: return "InventoryScanTime overflow,no UID collected";
                case communicationErr: return "Communication Error";
                case retCRCErr: return "CRC checksummat Error";
                case cmdNotOperation: return "CMD can't execute at current";
                case dataRangError: return "Operation data range error";
                default:
                    return "";
            }
        }

        private void ShowResultDialog(string cmdStr, int cmdRet, byte errorCode)
        {
            string s = "";
            try
            {
                if (!fAppClose)
                {
                    if (cmdRet == 0x10)
                    {
                        if (errorCode == 0)
                            s = cmdStr + ": \r\n" + GetReturnCodeDesc(cmdRet);
                        else
                            s = cmdStr + ": \r\n" + GetErrorCodeDesc(errorCode);
                    }
                    else
                    {
                        s = cmdStr + ": " + GetReturnCodeDesc(cmdRet) + "\r\n" + GetErrorCodeDesc(errorCode);
                    }
                    MessageBox.Show(s, "Information");
                }
            }
            finally
            {
                ;
            }
        }

        private void ShowResultDialog(string cmdStr, int cmdRet)
        {
            string tp;
            try
            {
                tp = GetReturnCodeDesc(cmdRet);
                if (tp != "")
                    MessageBox.Show(cmdStr + ": " + tp, "Information");
                else
                    MessageBox.Show(cmdStr + ": \r\n return " + "0x" + cmdRet.ToString("X2"), "Information"); ;
            }
            finally
            {
                ;
            }
        }

        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }

        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
            return sb.ToString().ToUpper();
        }
        public void ChangeSubItem(ListViewItem ListItem, int subItemIndex, string ItemText,string RSSI)
        {
            if (subItemIndex == 1)
            {
                if (ListItem.SubItems[subItemIndex].Text != ItemText)
                {
                    ListItem.SubItems[subItemIndex].Text = ItemText;
                    ListItem.SubItems[2].Text = "1";
                }
                else
                {
                    ListItem.SubItems[2].Text = Convert.ToString(Convert.ToUInt32(ListItem.SubItems[2].Text) + 1);
                    if ((Convert.ToUInt32(ListItem.SubItems[2].Text) > 9999))
                        ListItem.SubItems[2].Text = "1";
                }
                ListItem.SubItems[3].Text = RSSI;
            }

        }
        void callbeep()
        {
            while (queryflag1)
            {
                if (beepflag == true)
                {
                    MessageBeep(25);
                    Thread.Sleep(200);
                }
            }
        }
        bool beepflag = false;
        private void timer1_Tick(object sender, EventArgs e)
        {
               if (isStopInventory)
                   return;
               isStopInventory = true;
               int Totallen = 0;
               byte Ant = 0;
               int i, EPClen, m, n;
               n = 0;
               int CardNum = 0;
               string temp = "", temps = "", s = "", RSSI = "";
               byte[] EPC = new byte[32000];
               bool isonlistview;
               ListViewItem aListItem = new ListViewItem();
               if (tabControl1.SelectedIndex == 1)
               {
                   FastFlag = 1;
                   if ((MaskInfo.Session == 0) || (MaskInfo.Session == 1))
                   {
                       Target = 0;
                   }
                   else
                   {
                       if (AA_times > 1)
                       Target = Convert.ToByte(1 - Target);
                   }
                   Scantime = 10;
                   InAnt = 0x80;
                   fCmdRet = RWDev.Inventory_G2(ref readerAddr, MaskInfo.QValue, MaskInfo.Session, MaskInfo.MaskMem, MaskInfo.MaskAdr, MaskInfo.MaskLen,
                       MaskInfo.MaskData, MaskInfo.MaskFlag, MaskInfo.AdrTID, MaskInfo.LenTID, MaskInfo.TIDFlag, Target, InAnt, Scantime, FastFlag,EPC, ref Ant, ref Totallen, ref CardNum);
                   if (CardNum == 0)
                   {
                       beepflag = false;
                       if (MaskInfo.Session > 1)
                           AA_times = AA_times + 1;
                       isStopInventory = false;
                       return;
                   }
                   AA_times = 0;
                   beepflag = true;
                   if ((fCmdRet == 1) || (fCmdRet == 2))
                   {
                       byte[] daw = new byte[Totallen];
                       Array.Copy(EPC, daw, Totallen);
                       temps = ByteArrayToHexString(daw);
                       fInventory_EPC_List = temps;            //存贮记录
                       m = 0;
                       if (CardNum > 0)
                       {
                           for (i = 0; i < CardNum; i++)
                           {
                               EPClen = daw[m];
                               if (EPClen == 0)
                                   temp = "00";
                               else
                                   temp = temps.Substring(m * 2 + 2, EPClen * 2);
                               RSSI = temps.Substring(m * 2 + 2 + EPClen * 2, 2);
                               m = m + EPClen + 2;
                               isonlistview = false;
                               for (n = 0; n < ListView1_EPC.Items.Count; n++)     //判断是否在Listview列表内
                               {
                                   if (temp == ListView1_EPC.Items[n].SubItems[1].Text)
                                   {
                                       aListItem = ListView1_EPC.Items[n];
                                       ChangeSubItem(aListItem, 1, temp, RSSI);
                                       isonlistview = true;
                                       break;
                                   }
                               }
                               if (!isonlistview)
                               {
                                   aListItem = new ListViewItem();
                                   aListItem.SubItems.Add("");
                                   aListItem.SubItems.Add("");
                                   aListItem.SubItems.Add("");
                                   aListItem.SubItems.Add("");
                                   ListView1_EPC.Items.Add(aListItem);
                                   s = temp;
                                   aListItem.SubItems[0].Text = (ListView1_EPC.Items.Count).ToString();
                                   ChangeSubItem(aListItem, 1, s, RSSI);
                                   if (comboBox1.Items.IndexOf(temp) == -1)
                                   {
                                       comboBox1.Items.Add(temp);
                                       ComboBox_EPC5.Items.Add(temp);
                                   }
                               }
                           }
                       }
                   }
                   if ((comboBox1.Items.Count != 0))
                   {
                       comboBox1.SelectedIndex = 0;
                       ComboBox_EPC5.SelectedIndex = 0;
                   }
                   textBox10.Text = ListView1_EPC.Items.Count.ToString();
               }
               isStopInventory = false;
               Thread.Sleep((MaskInfo.scantime + 2) * 10);

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            RWDev.ModulePowerOff();
            RWDev.ModulePowerOn();
            button1.Enabled = false;
            button2.Enabled = false;
            button4.Enabled = false;
            button5.Enabled = false;
            button6.Enabled = false;
            button7.Enabled = false;
            button8.Enabled = false;
            for (i = 0; i < 31; i++)
                ComboBox_PowerDbm.Items.Add(i.ToString());
            ComboBox_PowerDbm.SelectedIndex = 0;
            i = 40;
            while (i <= 300)
            {
                comboBox2.Items.Add(Convert.ToString(i) + "ms");
                i = i + 10;
            }
            i = 3;
            while (i <= 256)
            {
                comboBox5.Items.Add(Convert.ToString(i) + "*100ms");
                i = i + 1;
            }
            comboBox5.SelectedIndex = 27;
            comboBox2.SelectedIndex = 1;
            Alarm_G2.Checked = true;
            comboBox4.SelectedIndex = 3;
            comboBox6.SelectedIndex = 1;
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
           RWDev.ModulePowerOff();
         //  RWDev.DisConnectReader();
           queryflag1 = false;
           beepflag = false;
           
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
           // readerAddr = 0xFF;
            byte[] VersionInfo=new byte[2];
            byte ReaderType=0;				
            byte TrType=0;		
            byte dmaxfre=0;           
            byte dminfre=0;       
            byte powerdBm=0;           
            byte ScanTime=0;
            byte Ant=0;
            byte BeepEn=0;          
            byte OutputRep=0;
            byte CheckAnt = 0;
            int result = 0x30;
            int i;
            byte fbaud = 5;
            string temp;
            readerAddr = 255;
            byte com_type = 0;
            fbaud = Convert.ToByte(comboBox4.SelectedIndex);
            if (fbaud > 2)
                fbaud = Convert.ToByte(fbaud + 2);
            else
                fbaud = Convert.ToByte(fbaud);
            result = RWDev.ConnectReader(ref readerAddr, fbaud, com_type);
            if (result == OK)
            {
                RWDev.GetReaderInformation(ref readerAddr, VersionInfo, ref ReaderType, ref TrType, ref dmaxfre, ref dminfre, ref powerdBm, ref ScanTime, ref Ant, ref BeepEn, ref OutputRep, ref CheckAnt);
               try
               {
                   temp = VersionInfo[0].ToString().PadLeft(2, '0') + "." + VersionInfo[1].ToString().PadLeft(2, '0');
                   tbVersion.Text = temp;
                   ComboBox_dmaxfre.Items.Clear();
                   ComboBox_dminfre.Items.Clear();
                   byte FreBand = Convert.ToByte(((dmaxfre & 0xc0) >> 4) | (dminfre >> 6));
                   m_band = FreBand;
                   switch (FreBand)
                   {
                       case 2://美标
                           {
                               comboBox6.SelectedIndex = 0;
                               ComboBox_dmaxfre.Items.Clear();
                               ComboBox_dminfre.Items.Clear();
                               for (i = 0; i < 50; i++)
                               {
                                   ComboBox_dminfre.Items.Add(Convert.ToString(902.75 + i * 0.5) + " MHz");
                                   ComboBox_dmaxfre.Items.Add(Convert.ToString(902.75 + i * 0.5) + " MHz");
                               }
                           }
                           break;
                       case 4://欧标
                           {
                               comboBox6.SelectedIndex = 1;
                               ComboBox_dmaxfre.Items.Clear();
                               ComboBox_dminfre.Items.Clear();
                               for (i = 0; i < 15; i++)
                               {
                                   ComboBox_dminfre.Items.Add(Convert.ToString(865.1 + i * 0.2) + " MHz");
                                   ComboBox_dmaxfre.Items.Add(Convert.ToString(865.1 + i * 0.2) + " MHz");
                               }
                           }
                           break;
                   }
                   Application.DoEvents();
                   Thread.Sleep(100);
                   ComboBox_dminfre.SelectedIndex = (dminfre & 0x3F);
                   ComboBox_dmaxfre.SelectedIndex = (dmaxfre & 0x3F);
                   if (fbaud > 3)
                       comboBox4.SelectedIndex = Convert.ToInt32(fbaud - 2);
                   else
                       comboBox4.SelectedIndex = Convert.ToInt32(fbaud);
                   ComboBox_PowerDbm.SelectedIndex = Convert.ToInt32(powerdBm);
                   comboBox5.SelectedIndex = Convert.ToInt32(ScanTime)-3;
                   btnConnect.Enabled = false;
                   btnDisconnect.Enabled = true;
                   button1.Enabled = true;
                   button2.Enabled = true;
                   button4.Enabled = true;
                   button5.Enabled = true;
                   button6.Enabled = true;
                   button7.Enabled = true;
                   button8.Enabled = true;
                   Button_WriteEPC_G2.Enabled = true;
                   Button_SetEASAlarm_G2.Enabled = true;
                   button3.Enabled = true;
                   fComopen = true;
               }
               catch (System.Exception ex)
               {
                   ex.ToString();
               }
            }
            else
            {
                MessageBox.Show("ConnectReader failed.", "Communication");
                btnConnect.Enabled = true;
                btnDisconnect.Enabled = false;
            }
        }


        private void btnDisconnect_Click(object sender, EventArgs e)
        {
            if (RWDev.DisConnectReader() == OK)
            {
        
                MessageBox.Show("DisconnectReader success.", "Communication");
                btnConnect.Enabled = true;
                btnDisconnect.Enabled = false;
                button1.Enabled = false;
                button2.Enabled = false;
                button4.Enabled = false;
                button5.Enabled = false;
                button6.Enabled = false;
                button7.Enabled = false;
                button8.Enabled = false;
                Button_WriteEPC_G2.Enabled = false;
                Button_SetEASAlarm_G2.Enabled = false;
                button3.Enabled = false;
                tbVersion.Text = "";
                fComopen = false;
                ComboBox_dminfre.Items.Clear();
                ComboBox_dmaxfre.Items.Clear();
            }
            else
            {
                MessageBox.Show("DisconnectReader failed.", "Communication");
                btnConnect.Enabled = false;
                btnDisconnect.Enabled = true;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            timer2.Enabled = !timer2.Enabled;
            if (!timer2.Enabled)
            {
                button1.Text = "Read";
            }
            else
            {
                textBox9.Text = "";
                //listBox1.Items.Clear();
                button1.Text = "Stop";
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            int result = 0x30;
            int Len = 0;
            byte ENum = 0;
            byte Mem = 0;
            byte Num = 0;
            byte WordPtr = 0;
            int Errorcode = 0;
            byte[] Password = new byte[4];
            byte[] Data = new byte[440];
            string str;
            if (comboBox1.Items.Count == 0)
                return;
            str = comboBox1.SelectedItem.ToString();
            if (str == "")
                return;
            ENum = Convert.ToByte(str.Length / 4);
            byte[] EPC = new byte[ENum];
            EPC = HexStringToByteArray(str);
            if (radioButton1.Checked)
                Mem = 0;
            if (radioButton2.Checked)
                Mem = 1;
            if (radioButton3.Checked)
                Mem = 2;
            if (radioButton4.Checked)
                Mem = 3;
            if (textBox1.Text == "")
                return;
            if (textBox2.Text == "")
                return;
            if (textBox3.Text == "" | textBox3.Text.Length!=8)
                return;
            WordPtr = Convert.ToByte(textBox1.Text, 16);
            Num = Convert.ToByte(textBox2.Text);
            Password = HexStringToByteArray(textBox3.Text);
            Len = Convert.ToByte(12 + ENum * 2);
            if (MaskInfo.MaskFlag == 1)
                ENum = 255;
            fCmdRet = RWDev.ReadData_G2(ref readerAddr, EPC, ENum, Mem, WordPtr, Num, Password,
                MaskInfo.MaskMem, MaskInfo.MaskAdr, MaskInfo.MaskLen, MaskInfo.MaskData, Data, ref Errorcode);
            textBox9.Text = "";
            if (fCmdRet == 0)
            {
                byte[] daw = new byte[Num * 2];
                Array.Copy(Data, daw, Num * 2);
                textBox9.Text = ByteArrayToHexString(daw);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int result = 0x30;
            byte WNum = 0;
            byte ENum = 0;
            byte Mem = 0;
            byte Num = 0;
            byte WordPtr = 0;
            int Errorcode = 0;
            byte[] Password = new byte[4];
            byte[] Data = new byte[440];
            string str,str1;
            if (comboBox1.Items.Count == 0)
                return;
            str = comboBox1.SelectedItem.ToString();
            if (str == "")
                return;
            ENum = Convert.ToByte(str.Length / 4);
            byte[] EPC = new byte[ENum*2];
            EPC = HexStringToByteArray(str);
            if (radioButton1.Checked)
                Mem = 0;
            if (radioButton2.Checked)
                Mem = 1;
            if (radioButton3.Checked)
                Mem = 2;
            if (radioButton4.Checked)
                Mem = 3;
            if (textBox1.Text == "")
                return;
            if (textBox2.Text == "")
                return;
            if (textBox3.Text == "" | textBox3.Text.Length != 8)
                return;
            if (textBox4.Text == "" | textBox4.Text.Length %4 !=0)
                return;
            str1 = textBox4.Text;
            WNum = Convert.ToByte(str1.Length / 4);
            byte[] writedata = new byte[WNum * 2];
            writedata = HexStringToByteArray(str1);
            WordPtr = Convert.ToByte(textBox1.Text, 16);
            Num = Convert.ToByte(textBox2.Text);
            Password = HexStringToByteArray(textBox3.Text);
            if (MaskInfo.MaskFlag == 1)
                ENum = 255;
            result = RWDev.WriteData_G2(ref readerAddr, EPC, WNum, ENum, Mem, WordPtr, writedata, Password, MaskInfo.MaskMem, MaskInfo.MaskAdr,
                MaskInfo.MaskLen, MaskInfo.MaskData, ref Errorcode);
            if (result == 0)
            {
                MessageBox.Show("Write success.", "Information");
            }
            else 
            {
                MessageBox.Show("Write Failed.", "Information");
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            byte powerDbm, dminfre, dmaxfre, fbaud, band;
            if (comboBox4.SelectedIndex > 2)
                fbaud = Convert.ToByte(comboBox4.SelectedIndex + 2);
            else
                fbaud = Convert.ToByte(comboBox4.SelectedIndex);
            if (comboBox6.SelectedIndex == 0)
                band = 2;
            else
                band = 4;
            dminfre = Convert.ToByte(((band & 3) << 6) | (ComboBox_dminfre.SelectedIndex & 0x3F));
            dmaxfre = Convert.ToByte(((band & 0x0c) << 4) | (ComboBox_dmaxfre.SelectedIndex & 0x3F));
            byte ScanTime = Convert.ToByte(comboBox5.SelectedIndex+3);
            if (ComboBox_dminfre.SelectedIndex > ComboBox_dmaxfre.SelectedIndex)
            {
                MessageBox.Show("dminfre > dmaxfre!", "Information");  
            }
            powerDbm = Convert.ToByte(ComboBox_PowerDbm.SelectedIndex);
            fCmdRet = RWDev.SetRfPower(ref readerAddr,powerDbm);
            fCmdRet = RWDev.SetRegion(ref readerAddr,dmaxfre,dminfre);
            fCmdRet = RWDev.SetInventoryScanTime(ref readerAddr, ScanTime);
            if (fCmdRet==0)
                MessageBox.Show("Update Success!", "Information");
            return;
        }

        private bool queryflag1 = false;
        Thread readThread1;
        private void button5_Click(object sender, EventArgs e)
        {
            timer1.Enabled = !timer1.Enabled;
            if (!timer1.Enabled)
            {
                button5.Text = "Scan";
                button11.Enabled = true;
                queryflag1 = false;
            }
            else
            {
                ListView1_EPC.Items.Clear();
                list.Clear();
                comboBox1.Items.Clear();
                ComboBox_EPC5.Items.Clear();
                textBox10.Text = "0";
                button5.Text = "Stop";
                button11.Enabled = false;
                readThread1 = new Thread(callbeep);
                queryflag1 = true;
                beepflag = false;
                readThread1.Priority = ThreadPriority.BelowNormal;
                readThread1.Start();
                Target = 0;              
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            timer3.Enabled = !timer3.Enabled;
            if (!timer3.Enabled)
            {
                button6.Text = "List Tag ID";
            }
            else
            {
                ListView_ID_6B.Items.Clear();
                comboBox3.Items.Clear();
                button6.Text = "Stop";
                CardNum1 = 0;
            }


        }
        public void ChangeSubItem_6B(ListViewItem ListItem, int subItemIndex, string ItemText)
        {
            if (subItemIndex == 1)
            {
                if (ListItem.SubItems[subItemIndex].Text != ItemText)
                {
                    ListItem.SubItems[subItemIndex].Text = ItemText;
                    ListItem.SubItems[2].Text = "1";
                }
                else
                {
                    ListItem.SubItems[2].Text = Convert.ToString(Convert.ToUInt32(ListItem.SubItems[2].Text) + 1);
                    if ((Convert.ToUInt32(ListItem.SubItems[2].Text) > 9999))
                        ListItem.SubItems[2].Text = "1";
                }
            }

        }
        private void Inventory6b()
        {
            byte[] ID_6B = new byte[2000];
            byte[] ID2_6B = new byte[5000];
  
            bool isonlistview;
            string temps;
            string s;
            byte ant = 0;
            ListViewItem aListItem = new ListViewItem();
            int i;
            byte[] ConditionContent = new byte[300];
            fCmdRet = RWDev.InventorySingle_6B(ref readerAddr ,ref ant, ID_6B);
            
            if (fCmdRet == 0)
            {
                byte[] daw = new byte[8];
                Array.Copy(ID_6B,1, daw,0, 8);
                temps = ByteArrayToHexString(daw);
                // comboBox3.Items.Add(temps);
                if (!list.Contains(temps))
                {
                    CardNum1 = CardNum1 + 1;
                    list.Add(temps);
                }
                isonlistview = false;
                for (i = 0; i < ListView_ID_6B.Items.Count; i++)     //判断是否在Listview列表内
                {
                    if (temps == ListView_ID_6B.Items[i].SubItems[1].Text)
                    {
                        aListItem = ListView_ID_6B.Items[i];
                        ChangeSubItem_6B(aListItem, 1, temps);
                        isonlistview = true;
                    }
                }
                if (!isonlistview)
                {
                    aListItem = new ListViewItem();
                    aListItem.SubItems.Add("");
                    aListItem.SubItems.Add("");
                    aListItem.SubItems.Add("");
                    ListView_ID_6B.Items.Add(aListItem);
                    s = temps;
                    aListItem.SubItems[0].Text = (ListView_ID_6B.Items.Count).ToString();
                    ChangeSubItem_6B(aListItem, 1, s);
                    if (comboBox3.Items.IndexOf(s) == -1)
                    {
                        comboBox3.Items.Add(temps);
                    }
                }
                MessageBeep(25);
                Thread.Sleep(200);
                if (comboBox3.Items.Count != 0)
                    comboBox3.SelectedIndex = 0;
            }
            
        }
        private void timer3_Tick(object sender, EventArgs e)
        {
            if (isStopInventory)
                return;
            isStopInventory = true;
            Inventory6b();
            isStopInventory = false;
        }

        private void button7_Click(object sender, EventArgs e)
        {
            timer4.Enabled = !timer4.Enabled;
            if (!timer4.Enabled)
            {
                button7.Text = "Read";
            }
            else
            {
                listBox2.Items.Clear();
                button7.Text = "Stop";
            }
        }
        private void Read6B()
        {
            string temp, temps;
            byte[] CardData = new byte[320];
            byte[] ID_6B = new byte[8];
            byte Num, StartAddress;
            int  ferrorcode=30;
            if (comboBox3.Items.Count == 0)
                return;
            if (comboBox3.SelectedItem == null)
                return;
            temp = comboBox3.SelectedItem.ToString();
            if (temp == "")
                return;
            ID_6B = HexStringToByteArray(temp);
            if (textBox5.Text == "")
                return;
            StartAddress = Convert.ToByte(textBox5.Text);
            if (textBox6.Text == "")
                return;
            Num = Convert.ToByte(textBox6.Text);
            fCmdRet = RWDev.ReadData_6B(ref readerAddr, ID_6B, StartAddress, Num, CardData, ref ferrorcode);
            if (fCmdRet == 0)
            {
                byte[] data = new byte[Num];
                Array.Copy(CardData, data, Num);
                temps = ByteArrayToHexString(data);
                listBox2.Items.Add(temps);
            }
            if (fAppClose)
                Close();
        }
        private void timer4_Tick(object sender, EventArgs e)
        {
            if (isStopInventory)
                return;
            isStopInventory = true;
            Read6B();
            isStopInventory = false;
        }

        private void button8_Click(object sender, EventArgs e)
        {
            string temp;
            byte[] CardData = new byte[320];
            byte[] ID_6B = new byte[8];
            byte StartAddress;
            byte Writedatalen;

            int errorcode = 30;
            if ((textBox7.Text == "") | ((textBox7.Text.Length % 2) != 0))
            {
                MessageBox.Show("Please input in bytes in hexadecimal form!", "Information");
                return;
            }
            if ((textBox5.Text == "") | (textBox6.Text == ""))
            {
                MessageBox.Show("Start address or length is empty!Please input!", "Information");
                return;
            }
            if (comboBox3.Items.Count == 0)
                return;
            if (comboBox3.SelectedItem == null)
                return;
            temp = comboBox3.SelectedItem.ToString();
            if (temp == "")
                return;
            ID_6B = HexStringToByteArray(temp);
            if (textBox5.Text == "")
                return;
            StartAddress = Convert.ToByte(textBox5.Text);
            Writedatalen = Convert.ToByte(textBox7.Text.Length / 2);
            byte[] Writedata = new byte[Writedatalen];
            Writedata = HexStringToByteArray(textBox7.Text);
            byte writtenbyte = 0;
            fCmdRet = RWDev.WriteData_6B(ref readerAddr,ID_6B, StartAddress, Writedata, Writedatalen,ref writtenbyte,ref errorcode);
            if(fCmdRet==0)
                MessageBox.Show("Write Success!!", "Information");
            else
                MessageBox.Show("Write Failed!", "Information");

        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox2.SelectedIndex < 6)
                timer3.Interval = 100;
            else
                timer3.Interval = (comboBox2.SelectedIndex + 4) * 10;
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (fComopen)
            {
                timer1.Enabled = false;
                timer2.Enabled = false;
                timer3.Enabled = false;
                timer4.Enabled = false;
                timer5.Enabled = false;
                button5.Text = "Scan";
                button1.Text = "Read";
                button6.Text = "List Tag ID";
                button7.Text = "Read";
                button3.Text = "Check Alarm";
                Button_SetEASAlarm_G2.Enabled = true;
                Button_WriteEPC_G2.Enabled = true;
                Alarm_G2.Enabled = true;
                NoAlarm_G2.Enabled = true;
                Label_Alarm.Visible = false;
            }
            queryflag1 = false;
            beepflag = false;
        }

        private void Button_WriteEPC_G2_Click(object sender, EventArgs e)
        {
            byte[] Password = new byte[4];
            byte nLen, WriteEPClen;
            byte ENum;
            int Errorcode = 0;
            if (Edit_AccessCode3.Text.Length < 8)
            {
                MessageBox.Show("Access Password Less Than 8 digit!Please input again!", "Information");
                return;
            }
            if ((Edit_WriteEPC.Text.Length % 4) != 0)
            {
                MessageBox.Show("Please input Data in words in hexadecimal form!", "Information");
                return;
            }
            WriteEPClen = Convert.ToByte(Edit_WriteEPC.Text.Length / 2);
            ENum = Convert.ToByte(Edit_WriteEPC.Text.Length / 4);
            byte[] EPC = new byte[ENum];
            EPC = HexStringToByteArray(Edit_WriteEPC.Text);
            Password = HexStringToByteArray(Edit_AccessCode3.Text);
            nLen =Convert.ToByte(9 + WriteEPClen);
            fCmdRet = RWDev.WriteEPC_G2(ref readerAddr, Password, EPC, ENum, ref Errorcode);
            if (fCmdRet == 0)
            {
                textBox8.Text = "Success!";
                if (ComboBox_EPC5.Items.IndexOf(Edit_WriteEPC.Text) == -1)
                {
                    ComboBox_EPC5.Items.Add(Edit_WriteEPC.Text);
                    ComboBox_EPC5.SelectedIndex = ComboBox_EPC5.Items.Count-1;
                }
            }
            else
                textBox8.Text = "Failed!"; 
        }

        private void Button_SetEASAlarm_G2_Click(object sender, EventArgs e)
        {
            byte EPClength = 0;
            byte EAS = 0;
            byte ENum;
            int Errorcode = 0;
            string str;
            byte[] Password = new byte[4];
            if (Edit_AccessCode5.Text.Length < 8)
            {
                MessageBox.Show("Access Password Less Than 8 digit!Please input again!", "Information");
                return;
            }
            if (ComboBox_EPC5.Items.Count == 0)
                return;
            if (ComboBox_EPC5.SelectedItem == null)
                return;
            str = ComboBox_EPC5.SelectedItem.ToString();
            if (str == "")
                return;
            ENum = Convert.ToByte(str.Length / 4);
            EPClength = Convert.ToByte(str.Length / 2);
            byte[] EPC = new byte[ENum];
            EPC = HexStringToByteArray(str);
            Password = HexStringToByteArray(Edit_AccessCode5.Text);
            if (Alarm_G2.Checked)
                EAS = 1;
            else
                EAS = 0;
            fCmdRet = RWDev.EASConfigure_G2(ref readerAddr, EPC, ENum, Password, EAS, MaskInfo.MaskMem, MaskInfo.MaskAdr, MaskInfo.MaskLen, MaskInfo.MaskData, ref Errorcode);
            if (fCmdRet == 0)
            {
                if (EAS == 1)
                    textBox8.Text = "Set EAS Alarm successfully";
                if (EAS == 0)
                    textBox8.Text = "ReSet EAS Alarm successfully";
            }
            else
                textBox8.Text = "Operation Failed";
        }

        private void button3_Click(object sender, EventArgs e)
        {
            timer5.Enabled = !timer5.Enabled;
            if (timer5.Enabled)
            {
                button3.Text = "Stop";
                Button_WriteEPC_G2.Enabled = false;
                Button_SetEASAlarm_G2.Enabled = false;
                Label_Alarm.Visible = false;
                Alarm_G2.Enabled = false;
                NoAlarm_G2.Enabled = false;
            }
            else
            {
                button3.Text = "Check Alarm";
                textBox8.Text = "'Check EAS Alarm'over";
                Button_WriteEPC_G2.Enabled = true;
                Button_SetEASAlarm_G2.Enabled = true;
                Label_Alarm.Visible = false;
                Alarm_G2.Enabled = true;
                NoAlarm_G2.Enabled = true;
            }
        }

        private void timer5_Tick(object sender, EventArgs e)
        {
            int Errorcode = 0;
            fCmdRet = RWDev.EASAlarm_G2(ref readerAddr, ref Errorcode);
            if (fCmdRet == 0)
            {
                textBox8.Text = "EAS alarm detected";
                Label_Alarm.Visible = true;
                MessageBeep(25);
            }
            else
            {
                textBox8.Text = "EAS alarm No detected!";
                Label_Alarm.Visible = false;
            }
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {

        }

        private void button9_Click(object sender, EventArgs e)
        {
            int result = 0x30;
            byte WNum = 0;
            byte ENum = 0;
            byte Num = 0;
            byte Mem = 0;
            byte WordPtr = 0;
            int Errorcode = 0;
            byte[] Password = new byte[4];
            byte[] Data = new byte[440];
            string str, str1;
            if (comboBox1.Items.Count == 0)
                return;
            str = comboBox1.SelectedItem.ToString();
            if (str == "")
                return;
            ENum = Convert.ToByte(str.Length / 4);
            byte[] EPC = new byte[ENum * 2];
            EPC = HexStringToByteArray(str);
            if (radioButton1.Checked)
                Mem = 0;
            if (radioButton2.Checked)
                Mem = 1;
            if (radioButton3.Checked)
                Mem = 2;
            if (radioButton4.Checked)
                Mem = 3;
            if (textBox1.Text == "")
                return;
            if (textBox2.Text == "")
                return;
            if (textBox3.Text == "" | textBox3.Text.Length != 8)
                return;
            if (textBox4.Text == "" | textBox4.Text.Length % 4 != 0)
                return;
            str1 = textBox4.Text;
            WNum = Convert.ToByte(str1.Length / 4);
            byte[] writedata = new byte[WNum * 2];
            writedata = HexStringToByteArray(str1);
            WordPtr = Convert.ToByte(textBox1.Text, 16);
            Num = Convert.ToByte(textBox2.Text);
            Password = HexStringToByteArray(textBox3.Text);
            result = RWDev.BlockWrite_G2(ref readerAddr, EPC, WNum, ENum, Mem, WordPtr, writedata, Password, MaskInfo.MaskMem, MaskInfo.MaskAdr,
                MaskInfo.MaskLen, MaskInfo.MaskData, ref Errorcode);
            if (result == 0)
            {
                MessageBox.Show("Write success.", "Information");
            }
            else
            {
                MessageBox.Show("Write Failed.", "Information");
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            textBox10.Text = "0";
            ListView1_EPC.Items.Clear();
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {

        }

        private void button11_Click(object sender, EventArgs e)
        {
            Condition cd = new Condition();
            cd.Show();
        }

        private void comboBox6_SelectedIndexChanged(object sender, EventArgs e)
        {
            ComboBox_dminfre.Items.Clear();
            ComboBox_dmaxfre.Items.Clear();
            if (comboBox6.SelectedIndex==0)
            {
                 for (int i = 0; i < 50; i++)
                {
                   ComboBox_dminfre.Items.Add(Convert.ToString(902.75 + i * 0.5) + " MHz");
                   ComboBox_dmaxfre.Items.Add(Convert.ToString(902.75 + i * 0.5) + " MHz");
                }
                ComboBox_dminfre.SelectedIndex = 0;
                ComboBox_dmaxfre.SelectedIndex = 49;
            }
            else
            {
                for (int i = 0; i < 15; i++)
                {
                    ComboBox_dminfre.Items.Add(Convert.ToString(865.1 + i * 0.2) + " MHz");
                    ComboBox_dmaxfre.Items.Add(Convert.ToString(865.1 + i * 0.2) + " MHz");
                }
                ComboBox_dminfre.SelectedIndex = 0;
                ComboBox_dmaxfre.SelectedIndex = 14;
            }

             
        }
     
    }
}